{*********************************************************}
{                                                         }
{       Borland Pascal 7.0                                }
{        ப.                                  }
{                                                         }
{       Copyright (c) 1997 by Alone SoftMaker             }
{                             Andy Petrusenco             }
{                                                         }
{*********************************************************}


unit StrCol;

interface

uses
  Objects, Strings;

type

  {==[ TStrCollection ]=====================================}
  {  ꥪ ।⠢ ᮡ  Pascal-ப }
  {=========================================================}
  PStrCollection = ^TStrCollection;
  TStrCollection = object(TCollection)
    procedure FreeItem(Item: Pointer); virtual;
    procedure PutItem(var S: TStream; Item: Pointer); virtual;
    function  GetItem(var S: TStream): Pointer; virtual;
  end; { TStrCollection }

  {==[ TPCharCollection ]===================================}
  {  ꥪ ।⠢ ᮡ  ASCIIZ-ப }
  {=========================================================}
  PPCharCollection = ^TPCharCollection;
  TPCharCollection = object(TCollection)
    procedure FreeItem(Item: Pointer); virtual;
    procedure PutItem(var S: TStream; Item: Pointer); virtual;
    function  GetItem(var S: TStream): Pointer; virtual;
  end; { TPCharCollection }

implementation

{====================[ TStrCollection ]===================}


  {==[ TStrCollection.FreeItem ]============================}
  {  ⮤ ᢮   ⮬       }
  { 樨 ᯮ ணࠬ DisposeStr             }
  {=========================================================}
  procedure TStrCollection.FreeItem;
  begin { TStrCollection.FreeItem }
    DisposeStr(Item);
  end; { TStrCollection.FreeItem }

  {==[ TStrCollection.PutItem ]=============================}
  { 뢠  樨  ⮪  ப         }
  {=========================================================}
  procedure TStrCollection.PutItem;
  begin { TStrCollection.PutItem }
    S.WriteStr(Item);
  end; { TStrCollection.PutItem }


  {==[ TStrCollection.GetItem ]=============================}
  { ⠥  樨  ⮪  ப           }
  {=========================================================}
  function TStrCollection.GetItem;
  begin { TStrCollection.GetItem }
    GetItem := S.ReadStr;
  end; { TStrCollection.GetItem }

{====================[ TPCharCollection ]===================}


  {==[ TPCharCollection.FreeItem ]==========================}
  {  ⮤ ᢮   ⮬       }
  { 樨 ᯮ ணࠬ StrDispose             }
  {=========================================================}
  procedure TPCharCollection.FreeItem;
  begin { TPCharCollection.FreeItem }
    StrDispose(Item);
  end; { TPCharCollection.FreeItem }

  {==[ TPCharCollection.PutItem ]===========================}
  { 뢠  樨  ⮪  ப         }
  {=========================================================}
  procedure TPCharCollection.PutItem;
  begin { TPCharCollection.PutItem }
    S.StrWrite(Item);
  end; { TPCharCollection.PutItem }


  {==[ TPCharCollection.GetItem ]===========================}
  { ⠥  樨  ⮪  ப           }
  {=========================================================}
  function TPCharCollection.GetItem;
  begin { TPCharCollection.GetItem }
    GetItem := S.StrRead;
  end; { TPCharCollection.GetItem }

end.

